#include <cmath>
#include <iostream>
using std::cout; using std::endl;

#include "ImageSequence.hpp"
#include "Fold.hpp"
#include "Learners.hpp"

int main(int argc, char **argv)
{
  // Load QAPs
  std::string adj_format = "data/house/house%03d.adj";
  std::string scf_format = "data/house/house%03d.scf";
  int baseline = 40;

  std::vector<QAP> qaps = imageSequence(111, baseline, adj_format, scf_format);

  // Construct 10-fold setup
  std::vector<Fold> folds = Fold::nfold(qaps, 10);

  // Perform learning
  BnBLearner learner;
  Fold::run(folds, learner);

  return 0;
}
