#include <cstring>

#include "ImageDatasets.hpp"

static const ImageDataset image_datasets[] = {
  {"house", 111, "data/house/house%03d.adj", "data/house/house%03d.scf", "data/house/nodes/%03d"},
  {"hotel", 101, "data/hotel/hotel%03d.adj", "data/hotel/hotel%03d.scf", "data/hotel/nodes/%03d"},
  {"rotate", 199, "data/silhouette/rotate/rotate%d.adj", "data/silhouette/rotate/rotate%d.scf", "data/silhouette/rotate/nodes/%03d"},
  {"shear", 199, "data/silhouette/shear/shear%d.adj", "data/silhouette/shear/shear%d.scf", "data/silhouette/shear/nodes/%03d"},
  {"noise", 199, "data/silhouette/noise/noise%d.adj", "data/silhouette/noise/noise%d.scf", "data/silhouette/noise/nodes/%03d"},
  {NULL, 0, NULL, NULL}
};


const ImageDataset *getDataset(const char *name)
{
  if(name == NULL) {
    return NULL;
  }

  for(const ImageDataset *d = image_datasets; d->name != NULL; d++) {
    if(strcmp(name, d->name) == 0) {
      return d;
    }
  }

  return NULL;
}
