#ifndef __IMAGE_SEQUENCE_HPP__
#define __IMAGE_SEQUENCE_HPP__

#include <vector>
#include <string>


#include "QAP/QAPSum.hpp"

/**
 * Construct a set of QAPSums from an image sequence.
 *
 * A given QAPSum will match images (i, i+baseline) in the sequence
 * for i=1,...,n.  Each QAPSum is a vector of various QAPs (similarity based).
 * The location of the .adj and .scf files will be
 * given by the formatting strings, which will be formatted with i
 * as input.
 */
std::vector<QAPSum> imageSequence(int n, int baseline,
				  const std::string &adj_format, const std::string &scf_format, const std::string &dis_format);

#endif // #ifndef __IMAGE_SEQUENCE_HPP__
