#include <cstdlib>
#include <cassert>
extern "C" {
#include <memory.h>
}

#include "QAP.hpp"
#include "QAPbranch.hpp"

#ifndef INFINITY
#define INFINITY (1.0/0.0)
#endif

bool QAPPaircomparison(pair<int,double> a, pair<int,double> b)
{
  return(a.second > b.second);
} 

QAP::QAP() :
  n(1), G1(1, 0), G2(1, 0)
{
}

QAP::QAP(const Graph &_G1, const Graph &_G2) :
  n(_G1.Nrows),
  G1(_G1), G2(_G2)
{
  assert(G2.Nrows == n);
}

QAP::QAP(const Graph &_G1, const Graph &_G2, const std::string &_label) :
  n(_G1.Nrows),
  G1(_G1), G2(_G2), label(_label)
{
  assert(G2.Nrows == n);
}

void QAP::permuteProblem(const Permutation &P)
{
  G2.permute(P);
}
