#ifndef __QAP_HPP__
#define __QAP_HPP__

#include <vector>

#include "Graph.hpp"
#include "SnSFclasses.hpp"
#include "Permutation.hpp"
#include "WTree.hpp"

using namespace SnSF;

class QAP 
{
public:
  int n;
  Graph G1, G2;
  std::string label;

  /**
   * Construct an empty QAP
   */
  QAP();

  /**
   * Construct a QAP for matching G1 to G2 with no unary costs.
   */
  QAP(const Graph &G1, const Graph &G2);

  /**
   * Construct a labeled QAP
   */
  QAP(const Graph &G1, const Graph &G2, const std::string &label);

  /**
   * Permute the problem, such that the true correspondence is permuted by @c P
   */
  void permuteProblem(const Permutation &P);
};

#endif // #ifndef __QAP_HPP__
