#include "SnSFclasses.hpp"
#include "Graph.hpp"
#include "QAP.hpp"

using namespace SnSF;

#define _branchCounter
#define _ops

#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

#ifdef _ops
ScalarCounter ops;
#endif

FGmatrix phiprime(FGmatrix B)
{
  int n = B.Nrows;

  FGmatrix Bp(false, n-2, n-2);
  
  for(int i = 0; i < n-2; i++) {
    for(int j = 0; j < n-2; j++) {
      Bp(i, j) = B(n-1, i) + B(n-2, j);
    }
  }

  return Bp;
}

int main(int argc, char** argv)
{
  //string s1 = argv[1]; 
  //string s2 = argv[2];
  //string s3 = argv[3];

  string s1 = "test6-G1.txt";
  string s2 = "house6V/house001_6V.txt";

  //string s1 = "test4-G1.txt";
  //string s2 = "test4-G1.txt";

  string s3 = "house6V/costmat_noise.txt";

  Graph G1(s1);
  Graph G2(s2);
  int n = G1.Nrows;

  Graph phi(s3);
  //Graph phi(Fmatrix(n, n, 1));

  Permutation truth(n); // TODO

  QAP qap(G1, G2, phi);

  WTree w(qap);

  Permutation result;

  //result = qap.solve(&w);
  //cout<<"Expanded: "<<w.nexpanded()<<endl;
  //cout<<"Result before training: "<<result<<endl;
  //getchar();

  qap.train(truth, &w);
  //getchar();

  //qap.train(truth, &w);
  //getchar();

  result = qap.solve(&w);
  cout<<"Expanded: "<<w.nexpanded()<<endl;
  cout<<"Result after training: "<<result<<endl;

  std::ofstream wfile("w.param", std::ios::out | std::ios::trunc);
  w.write(wfile);

  /*
  Permutation solution = qap.solve(&w);

  // Find objective function
  Function obj = qap.objectiveFunction(&w);
  cout<<"min = "<<obj.minimum()<<endl;
  cout<<"max = "<<obj.maximum()<<endl;

  cout<<"BnB: "<<solution<<endl;
  cout<<"BnB solution objective = "<<obj.eval(solution)<<endl;

  Permutation enum_sol = obj.maximumPermutation();
  cout<<"enum solution = "<<enum_sol<<endl;
  cout<<"enum solution objective = "<<obj.eval(enum_sol)<<endl;
  */
}
