#ifndef __LEARN_HPP__
#define __LEARN_HPP__

#include <vector>
#include <list>

#include "QAP.hpp"
#include "Permutation.hpp"
#include "WTree.hpp"

std::vector<int> readNodeList(const char *path);
std::list<QAP> loadFileList(const char *path);

void train(const std::list<QAP> &trainset, const std::vector<Permutation> &truth,
	   int nepochs, WTree *w);
std::vector<Permutation> test(const std::list<QAP> &QAPs, WTree *w);


double loss(const std::vector<Permutation> &truth, const std::vector<Permutation> &predict);


std::vector<Permutation> munkres(const std::list<QAP> &QAPs);

#endif // #ifndef __LEARN_HPP__
