#include <string>
#include <fstream>

#include "QAP.hpp"
#include "ScalarCounter.hpp"

ScalarCounter branchCounter;

using std::cout; using std::endl;

const char * const USAGE = "\
Usage: predict graph1 graph2 k1 k2 w\n\
";

int main(int argc, char **argv)
{
  if(argc != 6 || string(argv[1]) == "-h" || string(argv[1]) == "--help") {
    cout<<USAGE;
    return 0;
  }

  // Load QAP
  cout<<"Graph 1 "<<argv[1]<<endl;
  cout<<"Graph 2 "<<argv[2]<<endl;
  cout<<"k1     "<<argv[3]<<endl;
  cout<<"k2     "<<argv[4]<<endl;
  cout<<"w       "<<argv[5]<<endl;

  Graph G1 = Graph(string(argv[1]));
  Graph G2 = Graph(string(argv[2]));
  int n = G1.Nrows;
  
  Graph k1 = Graph(string(argv[3]));
  Graph k2 = Graph(string(argv[4]));

  QAP qap(G1, G2, k1, k2);

  // Load w
  std::ifstream wfile(argv[5], std::ios::in);
  WTree w(qap);
  w.read(wfile);

  // Perform prediction
  Permutation prediction = qap.solve(&w);

  cout<<prediction<<endl;

  return 0;
}
