#include "SnSFclasses.hpp"
#include "Graph.hpp"
#include "QAP.hpp"

using namespace SnSF;

#define _branchCounter
#define _ops

#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

#ifdef _ops
ScalarCounter ops;
#endif



main(int argc, char** argv){

  int n=6; if(argc>=2) sscanf(argv[1],"%d",&n);
  int method=0; if(argc>=3) sscanf(argv[2],"%d",&method);
  int squared=0; if(argc>=4) sscanf(argv[3],"%d",&squared);
  float thresh=0.5; if(argc>=5) sscanf(argv[4],"%f",&thresh);
  cout<<" "<<thresh<<endl;
  

  //Graph G1(string("A.txt"));
  Graph::RandomWeighted G1(n,thresh);
 cout<<"G1--"<<endl;
 cout<<G1.str()<<endl;
 cout<<"-----------------"<<endl;
  //Graph::Circuit G2(n);
  Graph::RandomWeighted G2(n,thresh);
 //cout<<"G2--"<<endl;
 //cout<<G2.str()<<endl;
  
  for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
      if (G2(i,j)!=0) G2(i,j)=1-G2(i,j);
  /*
  for(int i=0; i<n; i++)
    for(int j=0; j<n; j++)
      if(i!=j) G2(i,j)+=((double) rand())/((double)RAND_MAX+1)*0.5;
  */
  //cout<<"Target: "<<pow(G1.norm2(),2)<<endl;
 //cout<<"G2inverted--"<<endl;
 //cout<<G2.str()<<endl;

 Graph::RandomWeighted phi(n,thresh);
cout<<"phi--"<<endl;
 cout<<phi.str()<<endl;
 cout<<"-----------------"<<endl;
 getchar();
  Permutation::Random pi(n);

 cout<<"pi-"<<pi<<endl; 
  
 //G1.permute(pi);
  // cout<<"G1permuted--"<<endl;
  //cout<<G1(0,1)<<endl;
  //for(int i=0; i<n*n; i++) G2.a[i]=1-G2.a[i];
  //Graph::RandomWeighted G3(G2);
  //G3.permute(pi);
  //cout<<"Target: "<<G1.inp(G3)<<endl;
  
 

  // QAP qap(G1,G2,method,squared);
//   qap.solve();

  QAP qap(G1,G2,phi,method,squared);
  qap.solve();

  //cout<<pi.str()<<" ";
//cout<<pi<<" ";
  //cout<<Sn::Element(qap.bestseq).str()<<endl<<" ";
  //cout<<qap.negationoffset-qap.maxsofar<<" "<<((double)branchCounter())<<" "<<((double)ops())<<endl;



}


