function retw = wlearnSDP(wold, M, N, bnd, blocks)
    if iscell(M)
        if ~exists('blocks')
            blocks = cell(size(M));
            for i=1:numel(M)
                blocks{i} = ones(size(M{i}));
            end
        end
        
        M = blkdiag(M{:});
    end
    if iscell(N)
        N = blkdiag(N{:});
    end
    if iscell(blocks)
        blocks = blkdiag(blocks{:});
    end
       
    
    n = size(M, 1);
    
    cvx_begin;
        variable w(n,n);
        variable Mmod(n,n);
        variable Fmod(n,n);
        
        variable W1(n,n);
        variable W2(n,n);
        variable Z(2*n,2*n) symmetric;


        minimize norm(w - wold, 'fro');
        subject to


            Mmod == M .* w
            Mmod * N == Fmod

            w >= 0

            // Average constraint
            sum(sum(w(blocks ~= 0))) == sum(blocks(:));

            [W1 Fmod; Fmod' W2] == Z;
            Z == semidefinite(2*l);
            (0.5*trace(W1) + 0.5*trace(W2)) <= bnd;

    cvx_end;
    
    retM = wold;
end