#ifndef _SnSF
#define _SnSF

#include <vector>
#include <deque>
#include <iostream>
#include <sstream>

#include "base.h"
#include "Fmatrix.hpp"
#include "ScalarCounter.hpp"
#include "ExpressionTemplates.hpp"

// #define _branchCounter
// #define _ops

namespace SnSF{
  
  class Component;
  class ComponentDense;
  class ComponentDyad;
  class ComponentT;
  class Fourier;
  class FourierT;
  class Function;
  class Sfunction;
  class Transform;
  class TransformBank;
  class Correlation;
  template<class TYPE> class OuterProduct;
  template<class TYPE> class InnerProduct;
  //  template<class TYPE> class Product;
  // class graphletFunction;

};


#ifndef _SnSFOuterProduct
#define _SnSFOuterProduct

template<class TYPE>
class SnSF::OuterProduct{
public:
  OuterProduct(const TYPE& _first, const TYPE& _second):first(_first),second(_second){};
  const TYPE& first;
  const TYPE& second;
};

#endif


#ifndef _SnSFInnerProduct
#define _SnSFInnerProduct

template<class TYPE>
class SnSF::InnerProduct{
public:
  InnerProduct(const TYPE& _first, const TYPE& _second):first(_first),second(_second){};
  const TYPE& first;
  const TYPE& second;
};

#endif



#endif
