#ifndef _SnSFcomponentT
#define _SnSFcomponentT

#include "SnSF.hpp"
#include "PartitionB.hpp"
//#include "YoungDiagram.hpp"
#include "Tableau.hpp"

using namespace std;



class SnSF::ComponentT{
public:

  class Block;

  ComponentT(const PartitionB& _shape);
  // ComponentT(const YoungDiagram& _shape, const FourierT& subnode);
  ComponentT(const PartitionB& _shape, FourierT* subnode);
  ComponentT(const OuterProduct<ComponentT> op);
  ComponentT(const InnerProduct<ComponentT> op);
  virtual ~ComponentT();

  int YORleft(const int tau, const int T, double& c1, double& c2) const;
  void computeYORleft();
  int YORright(const int tau, const int T, double& c1, double& c2) const;
  void computeYORright();

  int rowIndex(const Tableau& t){
    for(int i=0; i<rowlabels.size(); i++) if(rowlabels[i]==t) return i; return -1;}
  int columnIndex(const Tableau& t){
    for(int i=0; i<columnlabels.size(); i++) if(columnlabels[i]==t) return i; return -1;}

  int readfrom(ifstream& ifs);
  int writeto(ofstream& ofs) const;

  string str() const;

  int n;
  // const YoungDiagram& shape; 
  PartitionB shape;
  vector<int> sub;
  // vector<Block> block; // obsolete
  bool pseudo;
  bool dyadic;

  int Nrows;
  vector<Tableau> rowlabels;
  bool rowcomplete;
  int* YORleftT;
  double* YORleft1;
  double* YORleft2;

  int Ncols;
  vector<Tableau> columnlabels;
  bool columncomplete;
  int* YORrightT;
  double* YORright1;
  double* YORright2;

};


class SnSF::ComponentT::Block{
public:
  Block(const int _Nrows, const int _Ncols, const int _index=0):Nrows(_Nrows),Ncols(_Ncols),index(_index){}
  int Nrows;
  int Ncols;
  int index;
};


#endif
