#ifndef _SnSFfourierT
#define _SnSFfourierT

#include <cassert>
#include <boost/shared_ptr.hpp>

#include "SnSF.hpp"
#include "PartitionB.hpp"
//#include "YoungDiagram.hpp"
#include "InheritableVector.hpp"

using namespace std;
using boost::shared_ptr;

class SnSF::FourierT: public InheritableVector<ComponentT*> {

public:
  FourierT(const int _n, const int _order=0);
  FourierT(const OuterProduct<FourierT> op);
  FourierT(const InnerProduct<FourierT> op);
  virtual ~FourierT() {}

  ComponentT* operator[](const int i) const {return at(i);}
  int operator[](const PartitionB& shape) const;

  int readfrom(ifstream& ifs);
  int writeto(ofstream& ofs) const;

  string str() const;

  int n;
  double order;

  FourierT *makeAncestorLeft(const PartitionB* limit = NULL);
  FourierT *makeDescendantLeft();

  FourierT *ancestor;
  FourierT *descendant;

};

#endif
