#include "SnSFtransform.hpp"

#include "SnSFfourierT.hpp"
#include "SnSFcomponentT.hpp"


SnSF::Transform::Left::Left(const int n, const int k, const PartitionB* limit){
  FourierT* prev=NULL;
  for(int i=1; i<=k; i++){
    FourierT* F=new FourierT(i,0);

    F->descendant=prev;
    if(prev!=NULL) {
      prev->ancestor=F;
    }

    push_back(F);
    prev = F;
  }
  

  PartitionB p(k,NULL);
  //cout<<"prev "<<prev<<endl;
  //cout<<"PartitionB "<<p.str()<<"Des of prev "<<prev->descendant<<endl;
 
  ComponentT& seed=*new ComponentT(p,prev->descendant);
  //cout<<seed.str()<<endl;
  //getchar();
  seed.columnlabels.push_back(Tableau(p));
  seed.Ncols=1;
  seed.pseudo=0;
  prev->push_back(&seed);
  prev->order=1;

  for(int i=k; i<n; i++){
    FourierT* F=prev->makeAncestorLeft(limit);
 //cout<<"Now anc of prev "<<F<<endl;
    push_back(F);
    prev=F;
//cout<<"prev "<<prev<<endl;
//getchar();
//cout<<"i m here"<<endl;
  }
}



SnSF::Transform::Left::Left(const OuterProduct<Transform> op){
  const Transform& first=op.first;
  const Transform& second=op.second;
  const int n=first.top().n;
  for(int i=0; i<n; i++) 
    push_back(NULL);
  at(n-1)=new FourierT(OuterProduct<FourierT>(*first[n-1],*second[n-1]));
  for(int i=n-1; i>=1; i--)
    at(i-1)=at(i)->makeDescendantLeft();
  at(0)->order=1; // hack!
  for(int i=2; i<=n; i++)
    at(i-1)->order=at(i-2)->order*i;
}



SnSF::Transform::Left::Left(const InnerProduct<Transform> op){ // incomplete: for now can't take iFT of double coset functions
  const Transform& first=op.first;
  const Transform& second=op.second;
  const int n=first.top().n;
  //for(int i=0; i<n; i++) push_back(NULL);
  push_back(new FourierT(InnerProduct<FourierT>(*first[n-1],*second[n-1])));
  //  for(int i=n-1; i>=1; i--)
  //  at(i-1)=at(i)->makeDescendantLeft();
  //at(0)->order=1; // hack!
  //for(int i=2; i<=n; i++)
  //  at(i-1)->order=at(i-2)->order*i;
}



#if 0
SnSF::Transform::Left::Left(const Product<Transform> op){
  const Transform& first=op.first;
  const Transform& second=op.second;
  const int n=first.top().n;
  for(int i=0; i<n; i++) 
    push_back(NULL);
  at(n-1)=new FourierT(OuterProduct<FourierT>(*first[n-1],*second[n-1]));
  for(int i=n-1; i>=1; i--)
    at(i-1)=at(i)->makeDescendantLeft();
  at(0)->order=1; // hack!
  for(int i=2; i<=n; i++)
    at(i-1)->order=at(i-2)->order*i;
}
#endif


SnSF::Transform::~Transform(){
  for(int i=0; i<size(); i++) delete at(i);
}


string SnSF::Transform::str() const{
  ostringstream result;
  for(int i=0; i<size(); i++){
    result<<"Level "<<at(i)->n<<endl;
    result<<at(i)->str();
  }
  return result.str();
}



int SnSF::Transform::readfrom(ifstream& ifs){
  int t; ifs.read(reinterpret_cast<char*>(&t),sizeof(int)); clear(); 
  FourierT* prev=NULL;
  for(int i=0; i<t; i++){
    FourierT* F=new FourierT(1,1);
    F->readfrom(ifs);
    F->descendant=prev;
    if(prev!=NULL) prev->ancestor=F;
    prev=F;
    push_back(F);
  }
}



int SnSF::Transform::writeto(ofstream& ofs) const{ 
  int t=size(); ofs.write(reinterpret_cast<char*>(&t),sizeof(int));
  for(int i=0; i<t; i++) at(i)->writeto(ofs);
}



