#ifndef _SnSFtransform
#define _SnSFtransform

#include "SnSF.hpp"
#include "PartitionB.hpp"
#include "InheritableVector.hpp"

using namespace std;

class SnSF::Transform: public InheritableVector<FourierT*> {
public:

  class Left;
  class Right;
  class Double;

  Transform(){};
  virtual ~Transform();
  
  FourierT& top() const {return *at(size()-1);}

  int readfrom(ifstream& ifs);
  int writeto(ofstream& ofs) const;

  string str() const;

};


class SnSF::Transform::Left: public Transform{
public:

  Left(const int n, const int k=1, const PartitionB* limit=NULL);
  Left(const OuterProduct<Transform> op);
  Left(const InnerProduct<Transform> op);
  virtual ~Left() {}

};



#endif
