#include <fstream>
#include <iostream>

#include "PartitionB.hpp"
#include "Tableau.hpp"
#include "SnSFcomponentT.hpp"
#include "SnSFfourierT.hpp"
#include "SnSFtransform.hpp"

#define _branchCounter
#define _ops

#ifdef _branchCounter
ScalarCounter branchCounter;
#endif

#ifdef _ops
ScalarCounter ops;
#endif

using namespace SnSF;

main(){

  PartitionB p(3,2,1,NULL);
  Transform::Left T(10,7);
  
  {
  PartitionB p(3,2,1,NULL);
  ofstream ofs("partition.file",ios::binary);
  p.writeto(ofs);
  ofs.close();
  cout<<p.str()<<endl;
  

  PartitionB p2;
  ifstream ifs("partition.file",ios::binary);
  p2.readfrom(ifs);
  ifs.close();
  cout<<p2.str()<<endl;
  }

  {
  PartitionB p(3,2,1,NULL);
  Tableau t(p);
  ofstream ofs("tableau.file",ios::binary);
  t.writeto(ofs);
  ofs.close();
  cout<<t.str()<<endl;
  

  Tableau t2;
  ifstream ifs("tableau.file",ios::binary);
  t2.readfrom(ifs);
  ifs.close();
  cout<<t2.str()<<endl;
  }

  if(0){
    ComponentT* cT=T.top().at(0);
    ofstream ofs("componentT.file",ios::binary);
    cT->writeto(ofs);
    ofs.close();
    cout<<cT->str()<<endl;
    delete cT;

    ComponentT cT2(p);
    ifstream ifs("componentT.file",ios::binary);
    cT2.readfrom(ifs);
    ifs.close();
    cout<<cT2.str()<<endl;
  }

  {
    FourierT* fT=&T.top();
    ofstream ofs("fourierT.file",ios::binary);
    fT->writeto(ofs);
    ofs.close();
    cout<<fT->str()<<endl;
    
    FourierT fT2(1,1);
    ifstream ifs("fourierT.file",ios::binary);
    fT2.readfrom(ifs);
    ifs.close();
    cout<<fT2.str()<<endl;
  }

  ofstream ofs("transformT.file",ios::binary);
  T.writeto(ofs);
  ofs.close();
  cout<<T.str()<<endl;
  
  Transform::Left T2(2,1);
  ifstream ifs("transformT.file",ios::binary);
  T2.readfrom(ifs);
  ifs.close();
  cout<<T2.str()<<endl;
  cout<<T2.top().n<<endl;
  
}
