/*This file is to run experiments for clarifications.
Author: Deepti Pachauri
Date: March 20 2012
 */
#include <cmath>
#include <iostream>
using std::cout; using std::endl;

#include "ImageSequence.hpp"
#include "Fold.hpp"
#include "Learners.hpp"
#include "QAP/StochasticGradient.hpp"

int main(int argc, char **argv)
{
  // Load QAPs
  std::string adj_format = "data/house/house%03d.adj";
  std::string scf_format = "data/house/house%03d.scf";
  std::string dis_format = "data/house/nodes/%03d";

  
  int baseline = 10;

  //To run the complete implementation on one graph pair.
  std::vector<QAPSum> Qs = imageSequence(110, baseline, adj_format, scf_format, dis_format);

  QAPSum::Weights WQ(Qs[0].m);
  std::vector<Permutation> p(Qs.size());
  for(int i = 0; i < p.size(); i++){
  p[i] = Permutation(Qs[0].n);
  }
  
  stochasticGradient(Qs,p,WQ, 1000, .001);
  // for(int i = 0; i < Qs.size(); i++) {
  //   cout<<Qs.solve(WQ)<<endl;
  // }

  
  return 0;
}
