#!/usr/bin/env python

import sys, os, os.path, glob, re

USAGE="""python aggregate.py <dataset> <suffix>

Example: python aggregate.py house nolearn-greedy

Will return a set of rows with baseline in the first column and overall
accuracy in the second column.
"""

def getAccuracy(path):
    f = file(path)

    for line in f:
        if line.strip() == 'Overall':
            break

    for line in f:
        line = line.strip()
        line[:9] == 'accuracy:'
        return float(line[9:].strip())

    print 'Error retrieving accuracy from', path
    return -1

# Read arguments
if len(sys.argv) != 3:
    print USAGE
    exit(1)
dataset = sys.argv[1]
suffix = sys.argv[2]

accs = []
paths = '%s/results/10fold-*-%s.txt' % (dataset, suffix)
basename_re = re.compile('10fold\-([0-9]+)\-%s\.txt' % suffix)

for path in glob.glob(paths):
    baseline = os.path.basename(path)
    if not basename_re.match(baseline):
        continue

    baseline = int(baseline.split('-')[1])
    accs.append((baseline, getAccuracy(path)))

accs.sort()
for baseline, accuracy in accs:
    print baseline, accuracy

