from PIL import Image
import random

#expname = sys.argv[1] # Where should the data be saved?
#imname = sys.argv[2]  # What image should be used?
#N = int(sys.argv[3])  # How many datapoints are there?

expname = "centaur/centaur"
imname = "creatures/centaur4.bmp"
N = 30

im = Image.open(imname)
M = 20 # How many samples should we take?

# Get a single pixel on the silhouette.
def sample(image):
  pix = 255
  (dimx,dimy) = image.size
  while (pix == 255):
    (x,y) = (int(random.random()*dimx), int(random.random()*dimy))
    pix = image.getpixel((x,y))
  return (x,y)

# Sample N points on the silhouette.
graph = []
for i in range(N):
  graph.append(sample(im))

# Jitter the graph by eps.
def jitter(g, eps):
  g2 = []
  for (v1, v2) in g:
    g2.append((v1 + random.random()*eps - eps/2, v2 + random.random()*eps - eps/2))
  return g2

for jit in range(0,21,2):
  for i in range(M):
    fverts = expname + "_" + str(jit) + "_" + str(i) + ".vert"
    g2 = jitter(graph, jit)

    fv = open(fverts, 'w')
    for j in range(N):
      (v1,v2) = g2[j]
      fv.write(str(v1) + " " + str(v2) + "\n")
    fv.close()

