from PIL import Image
from PIL import ImageDraw
import math
import random

from os import system

a = open("horse.corner", 'r')
b = a.readlines()
a.close
points = [[float(i) for i in l.split()] for l in b]

im = Image.open("creatures/horse3_white.bmp")

def psave(points, fname):
  a = open(fname, 'w')
  for (x,y) in points:
    a.write(str(x) + " " + str(y) + "\n")
  a.close()

# Shear...
for i in range(200):
  s = i / 100.0
  spoints = []
  for (x,y) in points:
    spoints.append((x + s*y, y))
  (sx, sy) = im.size
  im2 = im.transform((sx*(1 + s), sy), Image.AFFINE, (1, -s, 0, 0, 1, 0))
  #showim(im2, spoints)
  psave(spoints, "shear/shear"+str(i)+".corner")
  im2.save("shear/shear"+str(i)+".png")

# Rotate...
for i in range(200):
  theta = (math.pi/4)*i/100.0
  thetadeg = 45*i/100.0
  ctheta = math.cos(theta)
  stheta = math.sin(theta)
  spoints = []
  (sx, sy) = im.size
  (cx, cy) = (sx*0.5, sy*0.5)
  for (x,y) in points:
    spoints.append((ctheta*(x-cx) - stheta*(y-cy) + cx, stheta*(x-cx) + ctheta*(y-cy) + cy))
  im2 = im.rotate(-thetadeg)
  #showim(im2, spoints)
  psave(spoints, "rotate/rotate"+str(i)+".corner")
  im2.save("rotate/rotate"+str(i)+".png")

# Noise...
final = []
(sx, sy) = im.size
for (x,y) in points:
  (tx, ty) = (int(random.gauss(x, 20)), int(random.gauss(y, 20)))
  if (tx < 0): tx = 0
  if (tx >= sx): tx = sx - 1
  if (ty < 0): ty = 0
  if (ty >= sy): ty = sy - 1
  final.append((tx,ty))

for i in range(200):
  eps = i / 200.0
  spoints = []
  im2 = im
  for (p1, p2) in zip(points, final):
    (x,y) = p1
    (fx,fy) = p2
    spoints.append(((1 - eps)*x + eps*fx, (1 - eps)*y + eps*fy))
  psave(spoints, "noise/noise"+str(i)+".corner")
  im2.save("noise/noise"+str(i)+".png")

system("python makedata.py")
