#include "mxPerm.hpp"

Permutation permFromMx(const mxArray *mx)
{
  int n = (int)mxGetNumberOfElements(mx);
  int *perm_array = new int[n];
  mxArrayToIntArray(mx, perm_array);

  Permutation perm(n);
  for(int i = 0; i < n; i++) {
    perm[i] = perm_array[i];
  }

  delete [] perm_array;

  return perm;
}

mxArray *permToMx(const Permutation &perm)
{
  int n = perm.n;
  int *perm_array = new int[n];
  for(int i = 0; i < n; i++) {
    perm_array[i] = perm[i];
  }

  size_t dim = perm.n;
  mxArray *mx = mxArrayFromIntArray(1, &dim, perm_array);

  delete [] perm_array;

  return mx;
}
