#ifndef __MXPERM_HPP__
#define __MXPERM_HPP__

#include <mex.h>

#include "Permutation.hpp"
#include "mex_convert.h"

/**
 * Retrieve a permutation from a Matlab array.
 */
Permutation permFromMx(const mxArray *mx);

/**
 * Convert a permutation to a Matlab integer array.
 *
 * @note Caller is responsible for freeing result using mxDestroyArray
 */
mxArray *permToMx(const Permutation &perm);



#endif // #ifndef __MXPERM_HPP__
