#include <mex.h>

#include "mex_interface.h"
#include "mex_convert.h"

#include "Matlab.hpp"
#include "Graph.hpp"
#include "Permutation.hpp"
#include "mxPerm.hpp"

extern "C" void mexFunction(int nlhs, mxArray *plhs[], int nrhs, const mxArray *prhs[])
{
  mex_assert(nlhs == 1);
  mex_assert(nrhs == 4);

  // Read in costs
  Graph G1(matlab::FmatrixFromMx(prhs[0]));
  Graph G2(matlab::FmatrixFromMx(prhs[1]));
  Graph phi(matlab::FmatrixFromMx(prhs[2]));
  Permutation perm(permFromMx(prhs[3]));
  
  int n = G1.Nrows;

  // Check sizes
  mex_assert(G1.Nrows == G1.Ncols);
  mex_assert(G2.Nrows == G2.Ncols);
  mex_assert(phi.Nrows == phi.Ncols);
  mex_assert(G2.Nrows == n);
  mex_assert(phi.Nrows == n);
  mex_assert(perm.n == n);

  // Pass to QAPbranch_DP
  // TODO
  Graph newphi(phi);

  // Return adjusted phi
  plhs[0] = matlab::FmatrixToMx(newphi);
}
