#ifndef _ExpressionTemplates
#define _ExpressionTemplates



template<class Tleft, class Tright>
class Sum{
public:
  Sum(const Tleft& _left, const Tright& _right):left(_left),right(_right){};
  const Tleft& left;
  const Tright& right;
};


template<class Tleft, class Tright>
class Product{
public:
  Product(const Tleft& _left, const Tright& _right):left(_left),right(_right){};
  const Tleft& left;
  const Tright& right;
};


template<class TYPE>
class Transpose{
public:
  Transpose(const TYPE& _val):val(_val){};
  const TYPE& val;
};

//Added by DP for taking inverse 
template<class TYPE>
class Inverse{
public:
  Inverse(const TYPE& _val):val(_val){};
  const TYPE& val;
};
//
class Identity{
public:
};

/**
 * Expression of Hadamard element-wise product.
 */
template<class Tleft, class Tright>
class HadamardProduct {
public:
  HadamardProduct(const Tleft &_left, const Tright &_right) :
    left(_left), right(_right)
  {}

  const Tleft &left;
  const Tright &right;
};

/**
 * Expression of Hadamard element-wise division.
 *
 * The product is expressed by each element in left divided by the corresponding
 * element in right.
 */
template<class Tleft, class Tright>
class HadamardDivision {
public:
  HadamardDivision(const Tleft &_left, const Tright &_right) :
    left(_left), right(_right)
  {}

  const Tleft &left;
  const Tright &right;
};

#endif


#if 0

template<class Tleft, class Tright, class op>
class BinaryExpr{
public:
  BinaryExpr(const Tleft& _left, const Tright& _right):left(_left),right(_right){}
  const Tleft& left;
  const Tright& right;
};  


struct Mplus;
struct Mminus;
struct Mtimes;
struct Mtimes_T;
struct MtimesT_;
struct MtimesTT;


template<class TYPE>
Transpose<TYPE> operator~(const TYPE& o){return Transpose<TYPE>(o);}

template<class TYPE>
BinaryExpr<TYPE,TYPE,Mplus> operator+(const TYPE& left, const TYPE& right){return BinaryExpr<TYPE,TYPE,Mplus>(left,right);}

template<class TYPE>
BinaryExpr<TYPE,TYPE,Mminus> operator-(const TYPE& left, const TYPE& right){return BinaryExpr<TYPE,TYPE,Mminus>(left,right);}

template<class TYPE>
BinaryExpr<TYPE,TYPE,Mtimes> operator*(const TYPE& left, const TYPE& right){return BinaryExpr<TYPE,TYPE,Mtimes>(left,right);}


#endif
