#include "Lapack.hpp"

void FGmatrixFillLAPACK(const FGmatrix &A, int lda, doublereal *ptr)
{
  for(int j = 0; j < A.Ncols; j++) {
    for(int i = 0; i < A.Nrows; i++) {
      ptr[j * lda + i] = (doublereal)A(i, j);
    }
  }
}

doublereal *FGmatrixToLAPACK(const FGmatrix &A)
{
  doublereal *ptr = new double[A.Nrows * A.Ncols];
  FGmatrixFillLAPACK(A, A.Nrows, ptr);
  return ptr;
}

FGmatrix FGmatrixFromLAPACK(int Nrows, int Ncols, int lda, const doublereal *ptr)
{
  FGmatrix A(false, Nrows, Ncols);

  for(int i = 0; i < Nrows; i++) {
    for(int j = 0; j < Ncols; j++) {
      A(i, j) = (double)ptr[j*lda + i];
    }
  }

  return A;
}
