#include "PartitionB.hpp"

#include <iostream>
#include <sstream>
#include <stdarg.h>
#include <fstream>


PartitionB::PartitionB(const PartitionB& o){
  for(int i=0; i<o.size(); i++){
//cout<<"i in partitionB "<<i<<endl;
   push_back(o[i]);
  }
}



bool PartitionB::operator==(const PartitionB& o) const{
  if(size()!=o.size()) return 0;
  for(int i=0; i<size(); i++)
    if(at(i)!=o[i]) return 0;
  return 1;
}



bool PartitionB::limitedby(const PartitionB& o) const{
  if(size()>o.size()+1) return 0;
  int t1=0; int t2=0;
  for(int i=o.size()-1; i>=0; i--){
    t1+=o.at(i);
    if(size()>i+1) t2+=at(i+1);
    if (t2>t1) return 0;
  }
  return 1;
}



PartitionB::PartitionB(int a, ... ){
//cout<<"a "<<a<<endl;
  va_list params;
  int p=a;
  va_start(params,a);
  while(p!=0){
//cout<<"p "<<p<<endl;
    push_back(p);
    p=va_arg(params, int);
//cout<<"p "<<p<<endl;
//getchar();
  }
  va_end(params);
}


vector<PartitionB> PartitionB::restrictions() const{
  vector<PartitionB> result;
  for(int i=0; i<size(); i++){
    if(i==size()-1 || at(i)>at(i+1)){
      PartitionB p(*this); p[i]--;
      if(p[i]==0) p.pop_back();
      result.push_back(p);
    }
  }
  return result;
}


vector<PartitionB> PartitionB::extensions() const{
  vector<PartitionB> result;
  for(int i=0; i<size(); i++){
    if(i==0 || at(i-1)>at(i)){
      PartitionB p(*this); p[i]++;
      result.push_back(p);
    }
    PartitionB p(*this); 
    p.push_back(1);
    result.push_back(p);
  }
  return result;
}


string PartitionB::str() const{
  ostringstream result;
  result<<"("<<at(0);
  for(int i=1; i<size();i++)
    result<<","<<at(i);
  return result.str()+")";
}


int PartitionB::readfrom(ifstream& ifs){
  int t; 
  ifs.read(reinterpret_cast<char*>(&t),sizeof(int));
  resize(t);
  for(int i=0; i<t; i++)
    ifs.read(reinterpret_cast<char*>(&((*this)[i])),sizeof(int));  
}


int PartitionB::writeto(ofstream& ofs) const{
  int t=size();
  ofs.write(reinterpret_cast<const char*>(&t),sizeof(int));
  for(int i=0; i<t; i++)
    ofs.write(reinterpret_cast<const char*>(&((*this)[i])),sizeof(int));
}
