#ifndef _Permutation
#define _Permutation

#include <vector>
#include <iostream>
#include "InheritableVector.hpp"

using namespace std;

class CClist;

class Permutation: public InheritableVector<int>{
public:

  Permutation():n(0){}
  Permutation(const int _n):n(_n){
    for(int i=0; i<n; i++) push_back(i+1);};
  Permutation(const pair<int,int>& p);

  Permutation(int a1, int a2, ...);

  Permutation(const CClist& cclist);
  std::vector<int> cclist() const;

  int n;


  class Random;

  /**
   * Enumerate all permutations of n elements.
   */
  static vector<Permutation> enumerate(int n);

  /**
   * Compose two permutations.
   */
  const Permutation &compose(Permutation second);

  /**
   * Construct a permutation from a simple transposition
   */
  static Permutation transposition(int n, int i, int j);

  /**
   * Find the inverse mapping to a permutation.
   */
  Permutation inverse() const;
};
ostream& operator<<(ostream& stream, const Permutation& o);



class Permutation::Random : public Permutation{
public:
  Random(const int _n);
};


class CClist{
public:
  CClist(const vector<int>& _vec):vec(_vec){};
  // CClist(const Permutation& p);
  const vector<int>& vec;
};

bool operator == (const Permutation &, const Permutation &);

#endif
