/* -----------------------------------------------------------------------------

  SnOB - An FFT toolkit for the symmetric group
              development version

  Copyright (C) 2006  Imre Risi Kondor


  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the 

  Free Software Foundation, Inc., 
  51 Franklin Street, Fifth Floor, 
  Boston, MA  02110-1301, USA.

  This software is provided for educational and research purposes. 
  Commercial use is prohibited. 

  See the accompanying LICENSE for details

----------------------------------------------------------------------------- */


#ifndef _ScalarCounter
#define _ScalarCounter

#include <string>
#include <sstream>

using namespace std;

class ScalarCounter{
public:
  ScalarCounter():count(0){};

  int operator()(){return count;}
  int operator++(){return ++count;}
  int operator++(int){return count++;}
  int operator+=(const int a){count+=a; return count;}
  int reset(){count=0; return count;}

  string str(){
    ostringstream result;
    result<<"Number of scalar operations: "<<count;
    return result.str();
  }

  int count;

};


#endif
