#include "Tableau.hpp"

#include <fstream>
#include <sstream>


Tableau::Tableau(int n)
{
  shape=PartitionB(n,NULL);
  row.push_back(0);
  col.push_back(0);
  for(int i=1; i<=n; i++){
    row.push_back(1);
    col.push_back(i);
  }
}



Tableau::Tableau(const PartitionB& _shape):
  shape(_shape)
{
  row.push_back(0);
  col.push_back(0);
  for(int r=0; r<shape.size(); r++)
    for(int c=0; c<shape[r]; c++){
      row.push_back(r+1);
      col.push_back(c+1);
    }
}



Tableau& Tableau::growTo(const PartitionB& p){
  int n=p.n();
  for(int i=0; i<shape.size(); i++)
    if(shape[i]+1==p[i]){
      shape[i]++;
      row.push_back(i+1);
      col.push_back(p[i]);
      return *this;
    }
  shape.push_back(1);
  row.push_back(shape.size());
  col.push_back(1);
  return *this;
}



string Tableau::str() const{
  ostringstream R; 
  int n=shape.n();
  R<<"[";
  for(int i=0; i<row.size()-1; i++) R<<row[n-i];
  R<<"]";
  return R.str();
}


int Tableau::readfrom(ifstream& ifs){
  shape.readfrom(ifs);
  int t; 
  ifs.read(reinterpret_cast<char*>(&t),sizeof(int)); row.resize(t);
  for(int i=0; i<t; i++) ifs.read(reinterpret_cast<char*>(&(row[i])),sizeof(int));
  ifs.read(reinterpret_cast<char*>(&t),sizeof(int)); col.resize(t);
  for(int i=0; i<t; i++) ifs.read(reinterpret_cast<char*>(&(col[i])),sizeof(int));
}


int Tableau::writeto(ofstream& ofs) const{
  shape.writeto(ofs);
  int t;
  t=row.size(); ofs.write(reinterpret_cast<const char*>(&t),sizeof(int));
  for(int i=0; i<t; i++) ofs.write(reinterpret_cast<const char*>(&(row[i])),sizeof(int));
  t=col.size(); ofs.write(reinterpret_cast<const char*>(&t),sizeof(int));
  for(int i=0; i<t; i++) ofs.write(reinterpret_cast<const char*>(&(col[i])),sizeof(int));
}
