#ifndef __QAP_UTILITY_TIMER_HPP__
#define __QAP_UTILITY_TIMER_HPP__

extern "C" {
#include <sys/time.h>
}
#include <ctime>
#include <string>

class Timer
{
public:
  Timer();

  /**
   * Time in seconds since timer was last initialized or reset.
   */
  double elapsed() const;

  void reset();

  /**
   * Print time (in seconds) in human-readable form.
   */
  static std::string timeString(double s);

private:
  struct timeval t;

};

#endif // #ifndef __QAP_UTILITY_TIMER_HPP__
