#ifndef __CLUSTER_SAMPLE_H__
#define __CLUSTER_SAMPLE_H__

#include <stdlib.h>

typedef struct sample sample_t;

sample_t *sample_init(unsigned long int seed);
void sample_end(sample_t *);

double sample_uniform(sample_t *, double min, double max);

size_t sample_discrete(sample_t *, size_t k, const double *pi);

void sample_gaussian(sample_t *, size_t ndims, size_t n, double *p, const double *mu, const double *sigma);

void sample_MoG(sample_t *,
                size_t ndims, size_t n, double *p,
                size_t k, const double *pi, const double *mu,
                const double *sigma);

#endif // #ifndef __CLUSTER_SAMPLE_H__
