#include <FGmatrix.hpp>

#include <ctime>
#include <cstdlib>

#include <iomanip>

static inline double frand()
{
  return rand() / (double)RAND_MAX;
}

int main(int argc, char **argv)
{
  int n = 4;

  //srand(time(NULL));
  srand(0);

  // Create random input matrices
  FGmatrix A(false, n, n), B(false, n, n);
  for(int i = 0; i < n; i++) {
    for(int j = 0; j < n; j++) {
      A(i, j) = frand();
      B(i, j) = frand();
    }
  }
  cout<<"A = "<<endl<<A<<endl;
  cout<<"B = "<<endl<<B<<endl;

  // Find the various products
  Inverse<FGmatrix> invA(A);
  FGmatrix invA_B(Product<Inverse<FGmatrix>, FGmatrix>(invA, B));
  cout<<"inv(A) * B ="<<endl<<invA_B<<endl;

  cout<<"A * (inv(A) * B) ="<<endl<<FGmatrix(Product<FGmatrix, FGmatrix>(A, invA_B))<<endl;

  Inverse<FGmatrix> invB(B);
  FGmatrix A_invB(Product<FGmatrix, Inverse<FGmatrix> >(A, invB));
  cout<<"A * inv(B) ="<<endl<<A_invB<<endl;

  cout<<"(A * inv(B)) * B ="<<endl<<FGmatrix(Product<FGmatrix, FGmatrix>(A_invB, B))<<endl;
}
